]> git.saurik.com Git - bison.git/blob - bootstrap
* data/glr.c (yyparse): Don't assume that the initial calls
[bison.git] / bootstrap
1 #! /bin/sh
2
3 # Bootstrap this package from CVS.
4
5 # Copyright (C) 2003, 2004, 2005 Free Software Foundation, Inc.
6
7 # This program is free software; you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation; either version 2, or (at your option)
10 # any later version.
11
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
16
17 # You should have received a copy of the GNU General Public License
18 # along with this program; if not, write to the Free Software
19 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20 # 02110-1301, USA.
21
22 # Written by Paul Eggert.
23
24 package=bison
25
26 # Ensure file names are sorted consistently across platforms;
27 # e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
28 LC_ALL=C
29 export LC_ALL
30
31 # Parse options.
32
33 for option
34 do
35 case $option in
36 --help)
37 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
38 exit;;
39 --gnulib-srcdir=*)
40 GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
41 --cvs-user=*)
42 CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
43 --skip-po)
44 SKIP_PO=t;;
45 *)
46 echo >&2 "$0: $option: unknown option"
47 exit 1;;
48 esac
49 done
50
51 echo "$0: Bootstrapping CVS $package..."
52
53 build_cvs_prefix() {
54 CVS_PREFIX=:${1}:
55 if [ "${2}" != - ]; then
56 CVS_PREFIX=${CVS_PREFIX}${2}@
57 fi
58 }
59
60 # Get gnulib files.
61
62 case ${GNULIB_SRCDIR--} in
63 -)
64 if [ ! -d gnulib ]; then
65 echo "$0: getting gnulib files..."
66
67 trap exit 1 2 13 15
68 trap 'rm -fr gnulib; exit 1' 0
69
70 case ${CVS_AUTH-anoncvs} in
71 anoncvs)
72 CVS_PREFIX='anoncvs@';;
73 ssh)
74 CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
75 *)
76 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
77 exit 1;;
78 esac
79
80 case $CVS_RSH in
81 '') export CVS_RSH=ssh;;
82 esac
83
84 cvs -z3 -q -d ${CVS_PREFIX}subversions.gnu.org:/cvsroot/gnulib co gnulib || exit
85
86 trap - 0
87 fi
88 GNULIB_SRCDIR=gnulib
89 esac
90
91 <$GNULIB_SRCDIR/gnulib-tool || exit
92
93 gnulib_modules='
94 alloca
95 argmatch
96 dirname
97 error
98 extensions
99 getopt
100 gettext
101 hard-locale
102 hash
103 malloc
104 mbswidth
105 obstack
106 quote
107 quotearg
108 stdbool
109 stdio-safer
110 stpcpy
111 unistd-safer
112 xalloc
113 xalloc-die
114 xstrndup
115 '
116
117 previous_gnulib_modules=
118 while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
119 previous_gnulib_modules=$gnulib_modules
120 gnulib_modules=`
121 (echo "$gnulib_modules"
122 for gnulib_module in $gnulib_modules; do
123 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
124 done) | sort -u
125 `
126 done
127
128 gnulib_files=`
129 (for gnulib_module in $gnulib_modules; do
130 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
131 done) | sort -u
132 `
133
134 gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
135 mkdir -p $gnulib_dirs || exit
136
137 for gnulib_file in $gnulib_files; do
138 dest=$gnulib_file
139
140 case $gnulib_file in
141 m4/onceonly_2_57.m4) dest=m4/onceonly.m4;;
142 # These will be overwritten by autopoint, which still uses
143 # old jm_.* macro names, so we have to keep both copies.
144 # m4/gettext.m4 isn't mentioned here, since it's patched below.
145 m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
146 m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
147 m4/ulonglong.m4)
148 dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
149 esac
150
151 rm -f $dest &&
152 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
153 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
154 done
155
156 echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
157 sed '
158 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
159 AC_DEFUN([AM_INTL_SUBDIR], [])
160 ' m4/gettext.m4 >m4/gettext_gl.m4 || exit
161
162
163 # Get translations.
164
165 case $SKIP_PO in
166 '')
167 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
168 (cd po &&
169 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'` &&
170 wget -nv -nd -r -l 1 -A .po -C off \
171 http://www.iro.umontreal.ca/translation/maint/$package/ &&
172 ls *.po | sed 's/\.po$//' >LINGUAS
173 ) || exit
174
175 case $package in
176 bison)
177 echo "$0: getting translations into po (please ignore the robots.txt ERROR 404)..."
178 (cd runtime-po &&
179 rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po$/p'` &&
180 wget -nv -nd -r -l 1 -A .po -C off \
181 http://www.iro.umontreal.ca/translation/maint/$package-runtime/ &&
182 ls *.po | sed 's/\.po$//' >LINGUAS
183 ) || exit
184 esac;;
185 esac
186
187
188 # Generate autoconf and automake snippets.
189
190 (echo '# This file is generated automatically by "bootstrap".' &&
191 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
192 $GNULIB_SRCDIR/gnulib-tool --extract-autoconf-snippet $gnulib_modules &&
193 echo '])'
194 ) >m4/gnulib.m4 || exit
195
196 (echo '# This file is generated automatically by "bootstrap".' &&
197 $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules
198 ) >lib/gnulib.mk || exit
199
200
201 # Reconfigure, getting other files.
202
203 echo "$0: autoreconf --verbose --install --force ..."
204 autoreconf --verbose --install --force || exit
205
206
207 # We don't need intl, so remove it.
208 # Remove aclocal.m4 too, so that it gets rebuilt.
209 intl_files_to_remove='
210 aclocal.m4
211 intl
212 m4/codeset.m4
213 m4/gettext.m4
214 m4/glibc2.m4
215 m4/glibc21.m4
216 m4/intdiv0.m4
217 m4/intmax.m4
218 m4/inttypes_h.m4
219 m4/inttypes.m4
220 m4/inttypes-pri.m4
221 m4/isc-posix.m4
222 m4/lcmessage.m4
223 m4/lib-ld.m4
224 m4/lib-prefix.m4
225 m4/longdouble.m4
226 m4/longlong.m4
227 m4/po.m4
228 m4/printf-posix.m4
229 m4/signed.m4
230 m4/size_max.m4
231 m4/stdint_h.m4
232 m4/uintmax_t.m4
233 m4/ulonglong.m4
234 m4/wchar_t.m4
235 m4/wint_t.m4
236 m4/xsize.m4
237 '
238 echo $0: rm -fr $intl_files_to_remove ...
239 rm -fr $intl_files_to_remove || exit
240
241 # Put bug-reporting address into po/Makevars.
242 echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
243 sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
244
245 # Likewise for runtime-po/Makevars, except also change a few other parameters.
246 sed '
247 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
248 s/^\(subdir\) *=.*/\1 = runtime-po/
249 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YYI18N/
250 ' <po/Makevars >runtime-po/Makevars
251
252 # Copy identical files from po to runtime-po.
253 (cd po && cp -p *-quot *.header *.sed *.sin ../runtime-po)
254
255 # if src/parse-gram.[ch] are out of date, rebuild them.
256 parse_gram_y=`find src/parse-gram.y \
257 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
258 -print` || exit
259 case $parse_gram_y in
260 ?*)
261 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
262
263 echo "$0: touch -c src/parse-gram.[ch] ... "
264 touch -c src/parse-gram.[ch] || exit
265
266 echo "$0: ./configure --disable-nls ..."
267 ./configure --disable-nls || exit
268
269 echo "$0: (cd lib && make) ..."
270 (cd lib && make) || exit
271
272 echo "$0: (cd src && make) ..."
273 (cd src && make) || exit
274
275 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
276 rm -f src/parse-gram.c src/parse-gram.h || exit
277
278 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
279 (cd src && make parse-gram.c parse-gram.h) || exit
280
281 echo "$0: make distclean ..."
282 make distclean || exit;;
283 esac
284
285 echo "$0: done. Now you can run './configure'."